import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ListPrincipalThingsV2Command, se_ListPrincipalThingsV2Command } from "../protocols/Aws_restJson1";
export { $Command };
export class ListPrincipalThingsV2Command extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIotService", "ListPrincipalThingsV2", {})
    .n("IoTClient", "ListPrincipalThingsV2Command")
    .f(void 0, void 0)
    .ser(se_ListPrincipalThingsV2Command)
    .de(de_ListPrincipalThingsV2Command)
    .build() {
}
