import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ListThingPrincipalsV2Command, se_ListThingPrincipalsV2Command } from "../protocols/Aws_restJson1";
export { $Command };
export class ListThingPrincipalsV2Command extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIotService", "ListThingPrincipalsV2", {})
    .n("IoTClient", "ListThingPrincipalsV2Command")
    .f(void 0, void 0)
    .ser(se_ListThingPrincipalsV2Command)
    .de(de_ListThingPrincipalsV2Command)
    .build() {
}
